package code

type R int16

const (
	NoError R = iota
	FormatError
	ServerFailureError
	NameError
	NotImplementedError
	RefusedError
	YXDomainError  // Name Exists when it should not 		[RFC2136][RFC6672]
	YXRRSetError   // RR Set Exists when it should not 	[RFC2136]
	NXRRSetError   // RR Set that should exist does not 	[RFC2136]
	NotAuthError   // Server Not Authoritative for zone 	[RFC2136] [RFC8945]
	NotZoneError   // Name not contained in zone 			[RFC2136]
	DSOTYPENIError // DSO-TYPE Not Implemented 			[RFC8490]

	BADVERSOrBADSIGError R = 4 + iota // Bad OPT Version or TSIG Signature Failure	[RFC6891] [RFC8945]
	BADKEYError                       // Key not recognized 						[RFC8945]
	BADTIMEError                      // Signature out of time window				[RFC8945]
	BADMODEError                      // Bad TKEY Mode								[RFC2930]
	BADNAMEError                      // Duplicate key name							[RFC2930]
	BADALGError                       // Algorithm not supported					[RFC2930]
	BADTRUNCError                     // Bad Truncation								[RFC8945]
	BADCOOKIEError                    // Bad/missing Server Cookie					[RFC7873]
)

func (r *R) String() string {
	switch *r {
	case NoError:
		return ""
	case FormatError:
		return ""
	case ServerFailureError:
		return ""
	case NameError:
		return ""
	case NotImplementedError:
		return ""
	case RefusedError:
		return ""

	default:
		return "unknown"
	}
}
