package name

import (
	"strings"
)

type iterator struct {
	count int

	name []string

	current int
}

func newIterator(name []string) *iterator {
	return &iterator{
		count: len(name),
		name:  name,
	}
}

func (iterator *iterator) Next() bool {
	if iterator.current+1 < iterator.count {
		iterator.current++
		return true
	} else {
		return false
	}
}

func (iterator *iterator) Current() string {
	return iterator.name[iterator.current]
}

func (iterator *iterator) String() string {
	buffer := &strings.Builder{}
	for currentName := iterator.current; currentName < iterator.count; currentName++ {
		buffer.WriteString(iterator.name[currentName])
		if currentName+1 < iterator.count {
			buffer.WriteString(".")
		}
	}
	return buffer.String()
}
