package name

import (
	"io"
	"nproject.io/gitlab/root/dns/binary"
	"nproject.io/gitlab/root/dns/packet/pointer"
	"strings"
)

type Name struct {
	Name []string
}

func Parse(reader io.ReadSeeker) (*Name, error) {
	if nameList, err := read(reader,
		0); err == nil {
		return &Name{
			Name: nameList,
		}, nil
	} else {
		return nil, err
	}
}

func (name *Name) Write(writer binary.Writer,
	register pointer.Register) {
	iterator := newIterator(name.Name)

	for {
		if offset, ok := register.To(iterator.String()); ok {
			_ = writePointer(writer, uint16(offset))
			return
		} else {
			register.Register(iterator.String(),
				int16(writer.Len()))

			_ = binary.WriteInt8(writer, int8(len(iterator.Current())))
			_, _ = writer.Write([]byte(iterator.Current()))
		}

		if !iterator.Next() {
			_ = binary.WriteInt8(writer, 0)
			return
		}
	}
}

func (name *Name) String() string {
	buffer := &strings.Builder{}
	for currentNameIndex, currentName := range name.Name {
		buffer.WriteString(currentName)
		if currentNameIndex+1 < len(name.Name) {
			buffer.WriteString(".")
		}
	}
	return buffer.String()
}
