package name

import (
	"io"
	"nproject.io/gitlab/root/dns/binary"
)

func isPointer(value int8) bool {
	return uint8(value)&0xC0 == 0xC0
}

func read(reader io.ReadSeeker,
	depth int) ([]string, error) {
	result := make([]string, 0)
	tmp := make([]byte, 4)
	_, _ = reader.Read(tmp)
	reader.Seek(-4, io.SeekCurrent)
	for {
		if length, err := binary.ReadInt8(reader); err == nil {
			if isPointer(length) {
				if depth < maximumDepth {
					if _, err := reader.Seek(-1, io.SeekCurrent); err == nil {
						if offset, err := binary.ReadInt16(reader); err == nil {
							initialPosition, _ := reader.Seek(0, io.SeekCurrent)
							_, _ = reader.Seek(int64(offset&0x3FFF), io.SeekStart)
							pointerValue, err := read(reader, depth+1)
							_, _ = reader.Seek(initialPosition, io.SeekStart)
							return append(result,
								pointerValue...), err
						} else {
							return nil, err
						}
					} else {
						return nil, err
					}
				} else {
					return nil, TooDeepPointerError
				}
			} else {
				if length > 0 {
					word := make([]byte, length)
					if readLength, err := reader.Read(word); err == nil {
						if readLength == int(length) {
							result = append(result,
								string(word))
						} else {
							return nil, InvalidNameLengthError
						}
					} else {
						return nil, err
					}
				} else {
					break
				}
			}
		} else {
			return nil, err
		}
	}
	return result, nil
}
