package name

import (
	"github.com/stretchr/testify/require"
	"testing"
)

func Test_isPointer(t *testing.T) {
	type testType struct {
		name string

		givenValue uint8

		expectedResult bool
	}

	for _, currentTest := range []testType{
		{
			name:           "simple",
			givenValue:     0xC0,
			expectedResult: true,
		},
		{
			name:           "with additional data",
			givenValue:     0xCB,
			expectedResult: true,
		},
		{
			name:           "not a pointer",
			givenValue:     0x8B,
			expectedResult: false,
		},
	} {
		t.Run(currentTest.name,
			func(t *testing.T) {
				// given

				// when
				actualResult := isPointer(int8(currentTest.givenValue))

				// then
				require.Equal(t, currentTest.expectedResult, actualResult)
			},
		)
	}
}
