package pointer

type implementation struct {
	to map[string]int16
}

func New() Register {
	return &implementation{
		to: make(map[string]int16),
	}
}

func (implementation *implementation) Register(name string, to int16) bool {
	// as a name pointer is 2 bytes, we exclude all basics TLDs with length <= 3
	if len(name) <= 3 {
		return false
	}
	if _, ok := implementation.to[name]; ok {
		return false
	} else {
		implementation.to[name] = to
		return true
	}
}

func (implementation *implementation) To(name string) (int16, bool) {
	if at, ok := implementation.to[name]; ok {
		return at, true
	} else {
		return 0, false
	}
}
