package query

type Type int16

const (
	TypeA     Type = 1  // a host address
	TypeNS    Type = 2  // an authoritative name server
	TypeMD    Type = 3  // a mail destination (Obsolete - use MX)
	TypeMF    Type = 4  // a mail forwarder (Obsolete - use MX)
	TypeCNAME Type = 5  // the canonical name for an alias
	TypeSOA   Type = 6  // marks the start of a zone of authority
	TypeMB    Type = 7  // a mailbox domain name (EXPERIMENTAL)
	TypeMG    Type = 8  // a mail group member (EXPERIMENTAL)
	TypeMR    Type = 9  // a mail rename domain name (EXPERIMENTAL)
	TypeNULL  Type = 10 // a null RR (EXPERIMENTAL)
	TypeWKS   Type = 11 // a well known service description
	TypePTR   Type = 12 // a domain name pointer
	TypeHINFO Type = 13 // host information
	TypeMINFO Type = 14 // mailbox or mail list information
	TypeMX    Type = 15 // mail exchange
	TypeTXT   Type = 16 // text strings

	TypeOPT Type = 41 // https://datatracker.ietf.org/doc/html/rfc6891#section-6.1
)

type QType Type

const (
	TypeAXFR  QType = 252 // A request for a transfer of an entire zone
	TypeMAILB QType = 253 // A request for mailbox-related records (MB, MG or MR)
	TypeMAILA QType = 254 // A request for mail agent RRs (Obsolete - see MX)
	TypeStar  QType = 255 // A request for all records
)
