package extended

import (
	"io"
	"nproject.io/gitlab/root/dns/packet/code"
	"nproject.io/gitlab/root/dns/packet/header"
	"nproject.io/gitlab/root/dns/packet/name"
	"nproject.io/gitlab/root/dns/packet/record"
)

type Extended struct {
	Version int8
	RCode   code.R

	UDPPayloadSize uint16

	Option []Option

	DNSSecOk bool
}

func New(header *header.Header,
	name *name.Name,
	ttl int32,
	class int16,
	length int16,
	data []byte) (*Extended, error) {
	if len(name.Name) != 0 {
		return nil, record.InvalidExtendedRecordError
	}

	extended := &Extended{
		Version:        int8((ttl & 0xFF0000) >> 16),
		RCode:          code.R((uint32(ttl)&0xFFFF0000)>>20) | header.ResponseCode,
		UDPPayloadSize: uint16(class),
		DNSSecOk:       ttl&0x8000 == 0x8000,
	}

	if length > 0 {

	} else {
		extended.Option = make([]Option, 0)
	}

	return extended, nil
}

func (extended *Extended) Write(writer io.Writer) {

}
